Index: /pjproject/trunk/pjsip-apps/src/pygui/log.py
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pygui/log.py	(revision 5637)
+++ /pjproject/trunk/pjsip-apps/src/pygui/log.py	(revision 5638)
@@ -21,107 +21,108 @@
 import sys
 if sys.version_info[0] >= 3: # Python 3
-	import tkinter as tk
-	from tkinter import ttk
-	from tkinter import messagebox as msgbox
+    import tkinter as tk
+    from tkinter import ttk
+    from tkinter import messagebox as msgbox
 else:
-	import Tkinter as tk
-	import tkMessageBox as msgbox
-	import ttk
+    import Tkinter as tk
+    import tkMessageBox as msgbox
+    import ttk
 
 import pjsua2 as pj
 import application
 
+write=sys.stdout.write
 
 class LogWindow(tk.Toplevel):
-	"""
-	Log window
-	"""
-	instance = None
-	def __init__(self, app):
-		tk.Toplevel.__init__(self, name='logwnd', width=640, height=480)
-		LogWindow.instance = self
-		self.app = app
-		self.state('withdrawn')
-		self.title('Log')
-		self._createWidgets()
-		self.protocol("WM_DELETE_WINDOW", self._onHide)
+    """
+    Log window
+    """
+    instance = None
+    def __init__(self, app):
+        tk.Toplevel.__init__(self, name='logwnd', width=640, height=480)
+        LogWindow.instance = self
+        self.app = app
+        self.state('withdrawn')
+        self.title('Log')
+        self._createWidgets()
+        self.protocol("WM_DELETE_WINDOW", self._onHide)
 
-	def addLog(self, entry):
-		"""entry fields:
-		    int		level;
-		    string	msg;
-		    long	threadId;
-		    string	threadName;
-		"""
-		self.addLog2(entry.level, entry.msg)
-		
-	def addLog2(self, level, msg):
-		if level==5:
-			tags = ('trace',)
-		elif level==3:
-			tags = ('info',)
-		elif level==2:
-			tags = ('warning',)
-		elif level<=1:
-			tags = ('error',)
-		else:
-			tags = None
-		self.text.insert(tk.END, msg, tags)
-		self.text.see(tk.END)
-		
-	def _createWidgets(self):
-		self.rowconfigure(0, weight=1)
-		self.rowconfigure(1, weight=0)
-		self.columnconfigure(0, weight=1)
-		self.columnconfigure(1, weight=0)
-		
-		self.text = tk.Text(self, font=('Courier New', '8'), wrap=tk.NONE, undo=False, padx=4, pady=5)
-		self.text.grid(row=0, column=0, sticky='nswe', padx=5, pady=5)
-		
-		scrl = ttk.Scrollbar(self, orient=tk.VERTICAL, command=self.text.yview)
-		self.text.config(yscrollcommand=scrl.set)
-		scrl.grid(row=0, column=1, sticky='nsw', padx=5, pady=5)
+    def addLog(self, entry):
+        """entry fields:
+            int		level;
+            string	msg;
+            long	threadId;
+            string	threadName;
+        """
+        self.addLog2(entry.level, entry.msg)
 
-		scrl = ttk.Scrollbar(self, orient=tk.HORIZONTAL, command=self.text.xview)
-		self.text.config(xscrollcommand=scrl.set)
-		scrl.grid(row=1, column=0, sticky='we', padx=5, pady=5)
-		
-		self.text.bind("<Key>", self._onKey)
-		
-		self.text.tag_configure('normal', font=('Courier New', '8'), foreground='black')
-		self.text.tag_configure('trace', font=('Courier New', '8'), foreground='#777777')
-		self.text.tag_configure('info', font=('Courier New', '8', 'bold'), foreground='black')
-		self.text.tag_configure('warning', font=('Courier New', '8', 'bold'), foreground='cyan')
-		self.text.tag_configure('error', font=('Courier New', '8', 'bold'), foreground='red')
-	
-	def _onKey(self, event):
-		# Ignore key event to make text widget read-only
-		return "break"
-	
-	def _onHide(self):
-		# Hide when close ('x') button is clicked
-		self.withdraw()
-		self.app.showLogWindow.set(0)
-		
-	
+    def addLog2(self, level, msg):
+        if level==5:
+            tags = ('trace',)
+        elif level==3:
+            tags = ('info',)
+        elif level==2:
+            tags = ('warning',)
+        elif level<=1:
+            tags = ('error',)
+        else:
+            tags = None
+        self.text.insert(tk.END, msg, tags)
+        self.text.see(tk.END)
+
+    def _createWidgets(self):
+        self.rowconfigure(0, weight=1)
+        self.rowconfigure(1, weight=0)
+        self.columnconfigure(0, weight=1)
+        self.columnconfigure(1, weight=0)
+
+        self.text = tk.Text(self, font=('Courier New', '8'), wrap=tk.NONE, undo=False, padx=4, pady=5)
+        self.text.grid(row=0, column=0, sticky='nswe', padx=5, pady=5)
+
+        scrl = ttk.Scrollbar(self, orient=tk.VERTICAL, command=self.text.yview)
+        self.text.config(yscrollcommand=scrl.set)
+        scrl.grid(row=0, column=1, sticky='nsw', padx=5, pady=5)
+
+        scrl = ttk.Scrollbar(self, orient=tk.HORIZONTAL, command=self.text.xview)
+        self.text.config(xscrollcommand=scrl.set)
+        scrl.grid(row=1, column=0, sticky='we', padx=5, pady=5)
+
+        self.text.bind("<Key>", self._onKey)
+
+        self.text.tag_configure('normal', font=('Courier New', '8'), foreground='black')
+        self.text.tag_configure('trace', font=('Courier New', '8'), foreground='#777777')
+        self.text.tag_configure('info', font=('Courier New', '8', 'bold'), foreground='black')
+        self.text.tag_configure('warning', font=('Courier New', '8', 'bold'), foreground='cyan')
+        self.text.tag_configure('error', font=('Courier New', '8', 'bold'), foreground='red')
+
+    def _onKey(self, event):
+        # Ignore key event to make text widget read-only
+        return "break"
+
+    def _onHide(self):
+        # Hide when close ('x') button is clicked
+        self.withdraw()
+        self.app.showLogWindow.set(0)
+
+
 def writeLog2(level, msg):
-	if LogWindow.instance:
-		LogWindow.instance.addLog2(level, msg)	
+    if LogWindow.instance:
+        LogWindow.instance.addLog2(level, msg)
 
 def writeLog(entry):
-	if LogWindow.instance:
-		LogWindow.instance.addLog(entry)
+    if LogWindow.instance:
+        LogWindow.instance.addLog(entry)
 
 class Logger(pj.LogWriter):
-	"""
-	Logger to receive log messages from pjsua2
-	"""
-	def __init__(self):
-		pj.LogWriter.__init__(self)
-		
-	def write(self, entry):
-		print entry.msg,
-		writeLog(entry)
+    """
+    Logger to receive log messages from pjsua2
+    """
+    def __init__(self):
+        pj.LogWriter.__init__(self)
+
+    def write(self, entry):
+        write(entry.msg + "\r\n")
+        writeLog(entry)
 
 if __name__ == '__main__':
-	application.main()
+    application.main()
Index: /pjproject/trunk/pjsip-apps/src/swig/python/Makefile
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/python/Makefile	(revision 5637)
+++ /pjproject/trunk/pjsip-apps/src/swig/python/Makefile	(revision 5638)
@@ -1,3 +1,13 @@
 PYTHON_SO=_pjsua2.so
+
+USE_PYTHON3=1
+
+ifeq ($(USE_PYTHON3),1)
+  PYTHON_EXE=python3
+  PYTHON_PKG_DIR=$(HOME)/.local/lib/python3.6/site-packages
+else
+  PYTHON_EXE=python
+  PYTHON_PKG_DIR=$(HOME)/.local/lib/python2.7/site-packages
+endif
 
 #PYTHON_SETUP_FLAGS = --inplace 
@@ -17,5 +27,5 @@
 
 $(PYTHON_SO): pjsua2_wrap.cpp setup.py $(GCC_EXE)
-	python setup.py build $(PYTHON_SETUP_FLAGS)
+	$(PYTHON_EXE) setup.py build $(PYTHON_SETUP_FLAGS)
 
 gcc.exe: cc_mingw.c
@@ -31,8 +41,8 @@
 
 install:
-	python setup.py install --user
+	$(PYTHON_EXE) setup.py install --user
 
 uninstall:
-	rm -f $(HOME)/.local/lib/python2.7/site-packages/pjsua2*
-	rm -f $(HOME)/.local/lib/python2.7/site-packages/_pjsua2*
+	rm -f $(PYTHON_PKG_DIR)/pjsua2*
+	rm -f $(PYTHON_PKG_DIR)/_pjsua2*
 
Index: /pjproject/trunk/pjsip-apps/src/swig/python/setup.py
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/python/setup.py	(revision 5637)
+++ /pjproject/trunk/pjsip-apps/src/swig/python/setup.py	(revision 5638)
@@ -30,33 +30,35 @@
 pj_version_rev=""
 pj_version_suffix=""
+write=sys.stdout.write
 f = open('../../../../version.mak', 'r')
 for line in f:
+    tokens=""
     if line.find("export PJ_VERSION_MAJOR") != -1:
-    	tokens=line.split("=")
-	if len(tokens)>1:
-		pj_version_major= tokens[1].strip()
+        tokens=line.split("=")
+    if len(tokens)>1:
+        pj_version_major= tokens[1].strip()
     elif line.find("export PJ_VERSION_MINOR") != -1:
-    	tokens=line.split("=")
-	if len(tokens)>1:
-		pj_version_minor= line.split("=")[1].strip()
+        tokens=line.split("=")
+    if len(tokens)>1:
+        pj_version_minor= line.split("=")[1].strip()
     elif line.find("export PJ_VERSION_REV") != -1:
-    	tokens=line.split("=")
-	if len(tokens)>1:
-		pj_version_rev= line.split("=")[1].strip()
+        tokens=line.split("=")
+    if len(tokens)>1:
+        pj_version_rev= line.split("=")[1].strip()
     elif line.find("export PJ_VERSION_SUFFIX") != -1:
-    	tokens=line.split("=")
-	if len(tokens)>1:
-		pj_version_suffix= line.split("=")[1].strip()
+        tokens=line.split("=")
+    if len(tokens)>1:
+        pj_version_suffix= line.split("=")[1].strip()
 
 f.close()
 if not pj_version_major:
-    print 'Unable to get PJ_VERSION_MAJOR'
+    write("Unable to get PJ_VERSION_MAJOR" + "\r\n")
     sys.exit(1)
 
 pj_version = pj_version_major + "." + pj_version_minor
 if pj_version_rev:
-	pj_version += "." + pj_version_rev
+    pj_version += "." + pj_version_rev
 if pj_version_suffix:
-	pj_version += "-" + pj_version_suffix
+    pj_version += "-" + pj_version_suffix
 
 #print 'PJ_VERSION = "'+ pj_version + '"'
Index: /pjproject/trunk/pjsip-apps/src/swig/python/test.py
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/python/test.py	(revision 5637)
+++ /pjproject/trunk/pjsip-apps/src/swig/python/test.py	(revision 5638)
@@ -2,4 +2,6 @@
 import sys
 import time
+
+write=sys.stdout.write
 
 #
@@ -8,39 +10,39 @@
 #
 def ua_data_test():
-	#
-	# AuthCredInfo
-	#
-	print "UA data types test.."
-	the_realm = "pjsip.org"
-	ci = pj.AuthCredInfo()
-	ci.realm = the_realm
-	ci.dataType = 20
-	
-	ci2 = ci
-	assert ci.dataType == 20
-	assert ci2.realm == the_realm
-	
-	#
-	# UaConfig
-	# See here how we manipulate std::vector
-	#
-	uc = pj.UaConfig()
-	uc.maxCalls = 10
-	uc.userAgent = "Python"
-	uc.nameserver = pj.StringVector(["10.0.0.1", "10.0.0.2"])
-	uc.nameserver.append("NS1")
-	
-	uc2 = uc
-	assert uc2.maxCalls == 10
-	assert uc2.userAgent == "Python"
-	assert len(uc2.nameserver) == 3
-	assert uc2.nameserver[0] == "10.0.0.1"
-	assert uc2.nameserver[1] == "10.0.0.2"
-	assert uc2.nameserver[2] == "NS1"
+    #
+    # AuthCredInfo
+    #
+    write("UA data types test..")
+    the_realm = "pjsip.org"
+    ci = pj.AuthCredInfo()
+    ci.realm = the_realm
+    ci.dataType = 20
 
-	print "  Dumping nameservers: ",
-	for s in uc2.nameserver:
-		print s,
-	print ""
+    ci2 = ci
+    assert ci.dataType == 20
+    assert ci2.realm == the_realm
+
+    #
+    # UaConfig
+    # See here how we manipulate std::vector
+    #
+    uc = pj.UaConfig()
+    uc.maxCalls = 10
+    uc.userAgent = "Python"
+    uc.nameserver = pj.StringVector(["10.0.0.1", "10.0.0.2"])
+    uc.nameserver.append("NS1")
+
+    uc2 = uc
+    assert uc2.maxCalls == 10
+    assert uc2.userAgent == "Python"
+    assert len(uc2.nameserver) == 3
+    assert uc2.nameserver[0] == "10.0.0.1"
+    assert uc2.nameserver[1] == "10.0.0.2"
+    assert uc2.nameserver[2] == "NS1"
+
+    write("  Dumping nameservers: " + "\r\n")
+    for s in uc2.nameserver:
+        write(s  + "\r\n")
+    write("\r\n")
 
 #
@@ -48,18 +50,19 @@
 #
 def ua_run_test_exception():
-	print "Exception test.."
-	ep = pj.Endpoint()
-	ep.libCreate()
-	got_exception = False
-	try:
-		ep.natDetectType()
-	except pj.Error, e:
-		got_exception = True
-		print "  Got exception: status=%u, reason=%s,\n  title=%s,\n  srcFile=%s, srcLine=%d" % \
-			(e.status, e.reason, e.title, e.srcFile, e.srcLine)
-		assert e.status == 370050
-		assert e.reason.find("PJNATH_ESTUNINSERVER") >= 0
-		assert e.title == "pjsua_detect_nat_type()"
-	assert got_exception
+    write("Exception test.." + "\r\n")
+    ep = pj.Endpoint()
+    ep.libCreate()
+    got_exception = False
+    try:
+        ep.natDetectType()
+    except pj.Error as e:
+        #t, e = sys.exc_info()[:2]
+        got_exception = True
+        write("  Got exception: status=%u, reason=%s,\n  title=%s,\n  srcFile=%s, srcLine=%d" % \
+            (e.status, e.reason, e.title, e.srcFile, e.srcLine) + "\r\n")
+        assert e.status == 370050
+        assert e.reason.find("PJNATH_ESTUNINSERVER") >= 0
+        assert e.title == "pjsua_detect_nat_type()"
+    assert got_exception
 
 #
@@ -67,37 +70,37 @@
 #
 class MyLogWriter(pj.LogWriter):
-	def write(self, entry):
-		print "This is Python:", entry.msg
-		
+    def write(self, entry):
+        write("This is Python:" + entry.msg + "\r\n")
+
 #
 # Testing log writer callback
 #
 def ua_run_log_test():
-	print "Logging test.."
-	ep_cfg = pj.EpConfig()
-	
-	lw = MyLogWriter()
-	ep_cfg.logConfig.writer = lw
-	ep_cfg.logConfig.decor = ep_cfg.logConfig.decor & ~(pj.PJ_LOG_HAS_CR | pj.PJ_LOG_HAS_NEWLINE) 
-	
-	ep = pj.Endpoint()
-	ep.libCreate()
-	ep.libInit(ep_cfg)
-	ep.libDestroy()
-	
+    write("Logging test.." + "\r\n")
+    ep_cfg = pj.EpConfig()
+
+    lw = MyLogWriter()
+    ep_cfg.logConfig.writer = lw
+    ep_cfg.logConfig.decor = ep_cfg.logConfig.decor & ~(pj.PJ_LOG_HAS_CR | pj.PJ_LOG_HAS_NEWLINE)
+
+    ep = pj.Endpoint()
+    ep.libCreate()
+    ep.libInit(ep_cfg)
+    ep.libDestroy()
+
 #
 # Simple create, init, start, and destroy sequence
 #
 def ua_run_ua_test():
-	print "UA test run.."
-	ep_cfg = pj.EpConfig()
-	
-	ep = pj.Endpoint()
-	ep.libCreate()
-	ep.libInit(ep_cfg)
-	ep.libStart()
-	
-	print "************* Endpoint started ok, now shutting down... *************"
-	ep.libDestroy()
+    write("UA test run.." + "\r\n")
+    ep_cfg = pj.EpConfig()
+
+    ep = pj.Endpoint()
+    ep.libCreate()
+    ep.libInit(ep_cfg)
+    ep.libStart()
+
+    write("************* Endpoint started ok, now shutting down... *************" + "\r\n")
+    ep.libDestroy()
 
 #
@@ -105,54 +108,54 @@
 #
 def ua_tonegen_test():
-        print "UA tonegen test.."
-        ep_cfg = pj.EpConfig()
+    write("UA tonegen test.." + "\r\n")
+    ep_cfg = pj.EpConfig()
 
-        ep = pj.Endpoint()
-        ep.libCreate()
-        ep.libInit(ep_cfg)
-        ep.libStart()
-        
-        tonegen = pj.ToneGenerator()
-        tonegen.createToneGenerator()
+    ep = pj.Endpoint()
+    ep.libCreate()
+    ep.libInit(ep_cfg)
+    ep.libStart()
 
-        tone = pj.ToneDesc()
-        tone.freq1 = 400
-        tone.freq2 = 600
-        tone.on_msec = 1000
-        tone.off_msec = 1000
-        tones = pj.ToneDescVector()
-        tones.append(tone)
+    tonegen = pj.ToneGenerator()
+    tonegen.createToneGenerator()
 
-        digit = pj.ToneDigit()
-        digit.digit = '0'
-        digit.on_msec = 1000
-        digit.off_msec = 1000
-        digits = pj.ToneDigitVector()
-        digits.append(digit)
+    tone = pj.ToneDesc()
+    tone.freq1 = 400
+    tone.freq2 = 600
+    tone.on_msec = 1000
+    tone.off_msec = 1000
+    tones = pj.ToneDescVector()
+    tones.append(tone)
 
-        adm = ep.audDevManager()
-        spk = adm.getPlaybackDevMedia()
+    digit = pj.ToneDigit()
+    digit.digit = '0'
+    digit.on_msec = 1000
+    digit.off_msec = 1000
+    digits = pj.ToneDigitVector()
+    digits.append(digit)
 
-        tonegen.play(tones, True)
-        tonegen.startTransmit(spk)
-        time.sleep(5)
+    adm = ep.audDevManager()
+    spk = adm.getPlaybackDevMedia()
 
-	tonegen.stop()
-        tonegen.playDigits(digits, True)
-        time.sleep(5)
+    tonegen.play(tones, True)
+    tonegen.startTransmit(spk)
+    time.sleep(5)
 
-	dm = tonegen.getDigitMap()
-	print dm[0].digit
-	dm[0].freq1 = 400
-	dm[0].freq2 = 600
-	tonegen.setDigitMap(dm)
-	
-	tonegen.stop()
-        tonegen.playDigits(digits, True)
-        time.sleep(5)
-	
-        tonegen = None
+    tonegen.stop()
+    tonegen.playDigits(digits, True)
+    time.sleep(5)
 
-        ep.libDestroy()
+    dm = tonegen.getDigitMap()
+    write(dm[0].digit + "\r\n")
+    dm[0].freq1 = 400
+    dm[0].freq2 = 600
+    tonegen.setDigitMap(dm)
+
+    tonegen.stop()
+    tonegen.playDigits(digits, True)
+    time.sleep(5)
+
+    tonegen = None
+
+    ep.libDestroy()
 
 #
@@ -160,10 +163,10 @@
 #
 if __name__ == "__main__":
-	ua_data_test()
-	ua_run_test_exception()
-	ua_run_log_test()
-	ua_run_ua_test()
-	ua_tonegen_test()
-	sys.exit(0)
+    ua_data_test()
+    ua_run_test_exception()
+    ua_run_log_test()
+    ua_run_ua_test()
+    ua_tonegen_test()
+    sys.exit(0)
 
-	
+
